Attribute VB_Name = "otlcb95bas"
Option Explicit

'OTL variables
Type OtlSetup 'one per outline
    Levels As Integer
    VariableNames(5) As String 'Max 5 levels
    BmpField As String 'field holding bitmap to use for leafs if not use default
    CheckmarkField As String 'field to examine to determine if record is selected
    BmpFlag As Integer
    LineFlag As Integer
    PlusFlag As Integer
    CheckmarkFlag As Integer
    DisplayLines As Integer
    DisplayIdx(100) As Integer 'Max 100 lines visible
    DisplayCount As Integer 'virtual Ubound of displayidx
    VisibleItems As Integer
    VisChangeFlag As Integer
    LineHeight As Integer 'Twips
    ColWidth As Integer 'twips
    ElementClicked As Integer
    SelectColor As Long 'RGB
    SelectTextColor As Long
    FontName As String
    FontColor As Long
    Fontsize As Single
    TopIdx As Integer
    SelectIdx As Integer
    CurrentLine As Integer
    PrevTop As Integer
    PrevSel As Integer
End Type
Type OtlData  'Use in array
    Caption As String
    Level As Integer
    Visible As Integer
    Expanded As Integer
    VisibleIdx As Long
    Bookmark As String
    BmpFileName As String 'if not use default
    Selected As Integer '0-none, 1-all, 2-some
    SyncIdx As Integer 'Optional, sync to another array
    ItemData As Long
End Type

'standard images
Global gBranchOpenPic As Control
Global gBranchClosedPic As Control
Global gLeafPic As Control
Global gCustomPic As Control
Global gPlusPic As Control
Global gMinusPic As Control
'checked images
Global gBranchOpenAllPic As Control 'checked
Global gBranchClosedAllPic As Control
Global gBranchOpenSomePic As Control
Global gBranchClosedSomePic As Control
Global gLeafCheckedPic As Control
Dim ChangingScroll As Integer
'KeyCodes Constants
Const KEY_PRIOR = &H21
Const KEY_NEXT = &H22
Const KEY_END = &H23
Const KEY_HOME = &H24
Const KEY_LEFT = &H25
Const KEY_UP = &H26
Const KEY_RIGHT = &H27
Const KEY_DOWN = &H28
Const KEY_ADD = &H6B
Const KEY_SUBTRACT = &H6D
#If Win32 Then
    Declare Function BitBlt Lib "gdi32" (ByVal hDestDC%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal dwRop&) As Integer
    Declare Function StretchBlt Lib "gdi32" (ByVal hDestDC%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal nsrcWidth%, ByVal nsrcHeight%, ByVal dwRop&) As Integer
    Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
#Else
    Declare Function BitBlt Lib "GDI" (ByVal hDestDC%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal dwRop&) As Integer
    Declare Function StretchBlt Lib "GDI" (ByVal hDestDC%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal XSrc%, ByVal YSrc%, ByVal nsrcWidth%, ByVal nsrcHeight%, ByVal dwRop&) As Integer
    Declare Function SetPixel Lib "GDI" (ByVal hdc As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal crColor As Long) As Long
#End If

'Establishes the Bitmap objects for an outline control
Sub OutlineBmpSetup(BranchOpen As Control, BoFile As String, BranchClosed As Control, BcFile As String, Leaf As Control, LFile As String, CustomPic As Control)
On Error Resume Next

Set gBranchOpenPic = BranchOpen
Set gBranchClosedPic = BranchClosed
Set gLeafPic = Leaf
Set gCustomPic = CustomPic

If BoFile > "" Then gBranchOpenPic.Picture = LoadPicture(BoFile)
If BcFile > "" Then gBranchClosedPic.Picture = LoadPicture(BcFile)
If LFile > "" Then gLeafPic.Picture = LoadPicture(LFile)

End Sub
Sub OutlineBmpCheckedSetup(BranchOpenAll As Control, BranchClosedAll As Control, BranchOpenSome As Control, BranchClosedSome As Control, LeafChecked As Control)
On Error Resume Next

Set gBranchOpenAllPic = BranchOpenAll
Set gBranchClosedAllPic = BranchClosedAll
Set gBranchOpenSomePic = BranchOpenSome
Set gBranchClosedSomePic = BranchClosedSome
Set gLeafCheckedPic = LeafChecked

End Sub


'Processes a mouse click.
Sub OutlineClick(OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, OtlDat() As OtlData)
Dim foo As Integer
Dim Children As Integer
'set select
If OtlSet.CurrentLine > OtlSet.DisplayCount Then Exit Sub
If OtlSet.ElementClicked > 0 Then OtlSet.SelectIdx = OtlSet.DisplayIdx(OtlSet.CurrentLine)
'if pictureclick then select all or deselect all, don't expand
If OtlSet.ElementClicked = 1 And OtlSet.CheckmarkFlag Then
  OtlSet.VisChangeFlag = True
  If OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Selected = 1 Then
    OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Selected = 0
  Else
    OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Selected = 1
  End If
  'set child select
  For foo = OtlSet.DisplayIdx(OtlSet.CurrentLine) + 1 To UBound(OtlDat)
    If OtlDat(foo).Level <= OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Level Then Exit For
    OtlDat(foo).Selected = OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Selected
  Next foo
  'set parent selects
  CheckMarkParents OtlSet, OtlDat
Else
  'is it a branch?
  If OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Level < OtlSet.Levels - 1 Then
      OtlSet.VisChangeFlag = True
      'was it expanded?
      If OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Expanded = True Then
          'Collapse children
          For foo = OtlSet.DisplayIdx(OtlSet.CurrentLine) + 1 To UBound(OtlDat)
              If OtlDat(foo).Level <= OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Level Then Exit For
              OtlDat(foo).Expanded = False
              OtlDat(foo).Visible = False
          Next foo
      Else
          'Expand next level
          Children = 0
          For foo = OtlSet.DisplayIdx(OtlSet.CurrentLine) + 1 To UBound(OtlDat)
              If OtlDat(foo).Level <= OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Level Then
                  Exit For
              Else
                  If OtlDat(foo).Level = OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Level + 1 Then
                      OtlDat(foo).Expanded = False
                      OtlDat(foo).Visible = True
                      Children = Children + 1
                  End If
              End If
          Next foo
      End If
      OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Expanded = Not OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Expanded
      If Children + OtlSet.CurrentLine >= OtlSet.DisplayLines Then
        If Children < OtlSet.DisplayLines Then
          OtlSet.TopIdx = OtlSet.DisplayIdx((OtlSet.CurrentLine + Children + 1) - OtlSet.DisplayLines)
          OtlSet.SelectIdx = OtlSet.DisplayIdx(OtlSet.CurrentLine)
          OtlSet.CurrentLine = OtlSet.CurrentLine - (Children + 1)
        Else
          OtlSet.TopIdx = OtlSet.DisplayIdx(OtlSet.CurrentLine)
          OtlSet.SelectIdx = OtlSet.DisplayIdx(OtlSet.CurrentLine)
          OtlSet.CurrentLine = 0
        End If
          
      End If
      
  End If
End If
OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()

End Sub
Public Sub OutlineCopySelected(OtlDatSrc() As OtlData, OtlDatDest() As OtlData)
On Error Resume Next
Dim foo As Integer, foobar As Integer, foosync As Integer
ReDim LastParentExpanded(20) As Integer
ReDim OtlDatHold(UBound(OtlDatDest)) As OtlData
For foo = 0 To UBound(OtlDatDest)
  OtlDatHold(foo) = OtlDatDest(foo)
Next foo
ReDim OtlDatDest(UBound(OtlDatSrc)) As OtlData

foobar = -1
foosync = 0
For foo = 0 To UBound(OtlDatSrc)
  If OtlDatSrc(foo).Selected <> 0 Then
    foobar = foobar + 1
    OtlDatDest(foobar) = OtlDatSrc(foo)
    OtlDatDest(foobar).SyncIdx = foo
    If OtlDatDest(foobar).Level > 0 Then
      OtlDatDest(foobar).Visible = LastParentExpanded(OtlDatDest(foobar).Level - 1)
    Else
      OtlDatDest(foobar).Visible = True
    End If
    OtlDatDest(foobar).Expanded = False
    If foosync <= UBound(OtlDatHold) Then
      Do
        If OtlDatHold(foosync).SyncIdx = OtlDatDest(foobar).SyncIdx Then
          If OtlDatDest(foobar).Level > 0 Then OtlDatDest(foobar).Visible = OtlDatHold(foosync).Visible
          OtlDatDest(foobar).Expanded = OtlDatHold(foosync).Expanded
          Exit Do
        ElseIf OtlDatHold(foosync).SyncIdx > OtlDatDest(foobar).SyncIdx Then 'new one
          If OtlDatDest(foobar).Level > 0 Then OtlDatDest(foobar).Visible = LastParentExpanded(OtlDatDest(foobar).Level - 1)
          LastParentExpanded(OtlDatDest(foobar).Level) = OtlDatDest(foobar).Expanded
          Exit Do
        Else
          foosync = foosync + 1
        End If
        If foosync > UBound(OtlDatHold) Then Exit Do
      Loop
    End If
    LastParentExpanded(OtlDatDest(foobar).Level) = OtlDatDest(foobar).Expanded
  End If
Next foo
If foobar > 0 Then ReDim Preserve OtlDatDest(foobar) As OtlData

End Sub


Public Sub CheckMarkParents(OtlSet As OtlSetup, OtlDat() As OtlData)
Dim foo As Integer
ReDim LevelValue(OtlSet.Levels - 2) As Double
ReDim LevelCount(OtlSet.Levels - 2) As Integer
For foo = UBound(OtlDat) To 0 Step -1
  'handle control break if this is not a child
  If OtlDat(foo).Level <= OtlSet.Levels - 2 Then
    If LevelValue(OtlDat(foo).Level) = 0 Then
      OtlDat(foo).Selected = 0 'none selected
    Else
      If LevelCount(OtlDat(foo).Level) = LevelValue(OtlDat(foo).Level) Then
        OtlDat(foo).Selected = 1 'all selected
      Else
        OtlDat(foo).Selected = 2 'some selected
      End If
    End If
    LevelValue(OtlDat(foo).Level) = 0
    LevelCount(OtlDat(foo).Level) = 0
  End If
  If OtlDat(foo).Level > 0 Then
    'increment parent count
    Select Case OtlDat(foo).Selected
    Case 1
      LevelValue(OtlDat(foo).Level - 1) = LevelValue(OtlDat(foo).Level - 1) + 1
    Case 2
      LevelValue(OtlDat(foo).Level - 1) = LevelValue(OtlDat(foo).Level - 1) + 0.0001
    End Select
    LevelCount(OtlDat(foo).Level - 1) = LevelCount(OtlDat(foo).Level - 1) + 1
    
  End If
Next foo
End Sub

'Closes all open branches.

Sub OutlineCollapseAll(OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, OtlDat() As OtlData)
Dim foo As Integer
Dim TotVisible As Integer
For foo = 0 To UBound(OtlDat)
    If OtlDat(foo).Level > 0 Then
        OtlDat(foo).Visible = False
        OtlDat(foo).Expanded = False
    Else
        OtlDat(foo).Expanded = False
    End If
    If OtlDat(foo).Visible = True Then TotVisible = TotVisible + 1
Next foo
If OtlDat(OtlSet.SelectIdx).Visible = False Then OtlSet.SelectIdx = 0
If TotVisible <= OtlSet.DisplayLines Then
  OtlSet.TopIdx = 0
Else
  OtlSet.TopIdx = OtlSet.SelectIdx
End If
OtlSet.VisChangeFlag = True

OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()

End Sub


'Opens all branches.

Sub OutlineExpandAll(OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, OtlDat() As OtlData)
Dim foo As Integer

For foo = 0 To UBound(OtlDat)
    OtlDat(foo).Visible = True
    If OtlDat(foo).Level < OtlSet.Levels - 1 Then OtlDat(foo).Expanded = True
Next foo
OtlSet.VisChangeFlag = True

OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()

End Sub


'Locates text within the control.

Sub OutlineFind(FindItem As String, FindMode As Integer, OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, OtlDat() As OtlData)
Dim ItemStart As Integer, foo As Integer, foobar As Integer
Dim foo2 As Integer
If FindMode = 0 Then
    ItemStart = 0
Else
    ItemStart = OtlSet.SelectIdx + 1
End If
For foo = ItemStart To UBound(OtlDat)
    If InStr(1, OtlDat(foo).Caption, FindItem, 1) > 0 Then
        OtlSet.SelectIdx = foo
        OtlSet.TopIdx = foo
        If OtlDat(foo).Level <> 0 Then
            For foobar = foo To 0 Step -1
                If OtlDat(foobar).Level = 0 Then
                    OtlDat(foobar).Expanded = True
                    OtlDat(foobar).Visible = True
                    Exit For
                End If
            Next foobar
            For foo2 = foobar + 1 To UBound(OtlDat)
                If OtlDat(foo2).Level = 0 Then Exit For
                OtlDat(foo2).Visible = True
            Next foo2
        End If
        OtlSet.CurrentLine = 0
        OtlSet.VisChangeFlag = True
        OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()
        Exit Sub
    End If
Next foo
'item not found
Beep

End Sub


'Processes outline control keys

Sub OutlineKeyPress(KeyCode As Integer, OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, OtlDat() As OtlData)
Dim foo As Integer, VisCount As Integer
On Error Resume Next
Select Case KeyCode
Case KEY_ADD      '+ from numeric keypad
    If OtlDat(OtlSet.SelectIdx).Level < OtlSet.Levels - 1 And OtlDat(OtlSet.SelectIdx).Expanded = False Then
        OutlineClick OtlPic, OtlScroll, OtlSet, OtlDat()
    End If
Case KEY_SUBTRACT '- from numeric keypad
    If OtlDat(OtlSet.SelectIdx).Level < OtlSet.Levels - 1 And OtlDat(OtlSet.SelectIdx).Expanded = True Then
        OutlineClick OtlPic, OtlScroll, OtlSet, OtlDat()
    End If
Case KEY_PRIOR
    VisCount = 0
    foo = 0
    For foo = OtlSet.TopIdx To 1 Step -1
        If OtlDat(foo).Visible = True Then VisCount = VisCount + 1
        If VisCount = OtlSet.DisplayLines Then Exit For
    Next foo
    OtlSet.CurrentLine = 0
    OtlSet.TopIdx = foo
    OtlSet.SelectIdx = OtlSet.TopIdx
    OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()
Case KEY_NEXT
    For foo = OtlSet.DisplayLines - 1 To 0 Step -1
        If OtlSet.DisplayIdx(foo) > 0 Then
            OtlSet.TopIdx = OtlSet.DisplayIdx(foo)
            Exit For
        End If
    Next foo
    OtlSet.CurrentLine = 0
    OtlSet.SelectIdx = OtlSet.TopIdx
    OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()
Case KEY_END
    
Case KEY_HOME

Case KEY_UP
    If OtlSet.CurrentLine > 0 Then
        OtlSet.CurrentLine = OtlSet.CurrentLine - 1
        OtlSet.SelectIdx = OtlSet.DisplayIdx(OtlSet.CurrentLine)
    Else
        For foo = OtlSet.TopIdx - 1 To 0 Step -1
            If OtlDat(foo).Visible = True Then
                OtlSet.TopIdx = foo
                OtlSet.SelectIdx = OtlSet.TopIdx
                Exit For
            End If
        Next foo
    End If
    OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()
    
Case KEY_DOWN
    
    If OtlSet.CurrentLine < OtlSet.DisplayCount Then
        OtlSet.CurrentLine = OtlSet.CurrentLine + 1
        OtlSet.SelectIdx = OtlSet.DisplayIdx(OtlSet.CurrentLine)
    Else
        For foo = OtlSet.DisplayIdx(OtlSet.CurrentLine) + 1 To UBound(OtlDat)
            If OtlDat(foo).Visible = True Then
                OtlSet.TopIdx = OtlSet.DisplayIdx(1)
                OtlSet.SelectIdx = foo
                Exit For
            End If
        Next foo
    End If
    OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()

Case Else
End Select
End Sub


'Loads outline from data set.
Sub OutlineLoadRecordset(OtlSet As OtlSetup, OtlDat() As OtlData, RecSet As Recordset, ItemDataFields As String)
On Error Resume Next
Dim foo As Integer, ItemCount As Long, WriteSubs As Integer
ReDim ItemDataField(OtlSet.Levels - 1) As String
Static AlphaMode As Integer
ReDim PrevVal(5)
RecSet.MoveFirst
If Err <> 0 And Err <> 3021 Then
    Beep
    MsgBox "Data Access Error Loading RecSetset: " & Err & " - " & Error, 16, "Data Access Error!"
    Exit Sub
End If
If ItemDataFields > "" Then
  For foo = 1 To OtlSet.Levels
    ItemDataField(foo - 1) = ParseListText(ParseString:=ItemDataFields, ReturnPosition:=(foo), Delimiter:=",")
    If ItemDataField(foo - 1) = "" And foo > 0 Then ItemDataField(foo - 1) = ItemDataField(foo - 2)
  Next foo
End If
ReDim OtlDat(0)
AlphaMode = False
Do Until RecSet.EOF
    'Check for header's control breaks
    If OtlSet.Levels = 1 Or AlphaMode Then
        OtlSet.Levels = 2
        AlphaMode = True
        'setup by alpha
        If PrevVal(0) <> Mid$(Format$(RecSet(OtlSet.VariableNames(0))), 1, 1) Then
            PrevVal(0) = Mid$(Format$(RecSet(OtlSet.VariableNames(0))), 1, 1)
            OtlDat(ItemCount).Caption = "-" & PrevVal(0) & "-"
            OtlDat(ItemCount).Level = 0
            OtlDat(ItemCount).Visible = True
            OtlDat(ItemCount).Expanded = False
            OtlDat(ItemCount).Bookmark = ""
            ItemCount = ItemCount + 1
            If UBound(OtlDat) < ItemCount Then
                ReDim Preserve OtlDat(UBound(OtlDat) + 100)
            End If
        End If
    Else
        'setup by data value
        WriteSubs = False
        For foo = 0 To OtlSet.Levels - 2
            If (PrevVal(foo) <> RecSet(OtlSet.VariableNames(foo))) Or (WriteSubs = True) Then
                If IsNull(RecSet(OtlSet.VariableNames(foo))) Then
                  OtlDat(ItemCount).Caption = "#Null#"
                  OtlDat(ItemCount).ItemData = -1
                Else
                  OtlDat(ItemCount).Caption = Format$(RecSet(OtlSet.VariableNames(foo)))
                  If ItemDataField(foo) > "" Then OtlDat(ItemCount).ItemData = RecSet(ItemDataField(foo))
                End If
                PrevVal(foo) = RecSet(OtlSet.VariableNames(foo))
                WriteSubs = True 'force write of subheaders
                OtlDat(ItemCount).Level = foo
                If foo = 0 Then
                    OtlDat(ItemCount).Visible = True
                Else
                    OtlDat(ItemCount).Visible = False
                End If
                OtlDat(ItemCount).Expanded = False
                OtlDat(ItemCount).Bookmark = ""
                ItemCount = ItemCount + 1
                If UBound(OtlDat) < ItemCount Then
                    ReDim Preserve OtlDat(UBound(OtlDat) + 100)
                End If
            End If
        Next foo
    End If
    'Write leaf (AlphaMode reference corrects for fake 2nd level)
    If IsNull(RecSet(Trim$(OtlSet.VariableNames(OtlSet.Levels - 1 + AlphaMode)))) Then
      OtlDat(ItemCount).Caption = "#Null#"
      OtlDat(ItemCount).ItemData = -1
    Else
      OtlDat(ItemCount).Caption = Format$(RecSet(Trim$(OtlSet.VariableNames(OtlSet.Levels - 1 + AlphaMode))))
      If ItemDataField(OtlSet.Levels - 1 + AlphaMode) > "" Then OtlDat(ItemCount).ItemData = RecSet(ItemDataField(OtlSet.Levels - 1 + AlphaMode))
    End If
    OtlDat(ItemCount).Level = OtlSet.Levels - 1
    OtlDat(ItemCount).Visible = False
    OtlDat(ItemCount).Expanded = False
    OtlDat(ItemCount).Bookmark = RecSet.Bookmark
    If OtlSet.BmpField > "" Then OtlDat(ItemCount).BmpFileName = RecSet(OtlSet.BmpField) Else OtlDat(ItemCount).BmpFileName = ""
    'is data seelction on?
    If OtlSet.CheckmarkFlag And OtlSet.CheckmarkField > "" Then
      If RecSet(OtlSet.CheckmarkField) Then
        OtlDat(ItemCount).Selected = 1
      End If
    End If
    ItemCount = ItemCount + 1
    If UBound(OtlDat) < ItemCount Then
        ReDim Preserve OtlDat(UBound(OtlDat) + 100)
    End If
    RecSet.MoveNext
Loop
'resize to get rid of extra elements
ReDim Preserve OtlDat(ItemCount - 1)
'set checkmarks if checkmarkable
If OtlSet.CheckmarkFlag Then
  CheckMarkParents OtlSet, OtlDat
End If
End Sub


'Processes MouseDown to get coordinates of click.

Sub OutlineMouseDown2Line(OtlSet As OtlSetup, OtlDat() As OtlData, Y As Single, X As Single)
On Error Resume Next
OtlSet.CurrentLine = Y \ OtlSet.LineHeight
OtlSet.ElementClicked = (X - OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Level * OtlSet.ColWidth) \ OtlSet.ColWidth '0=+/-, 1=Pic, 2=Caption
If OtlSet.ElementClicked > 2 Then OtlSet.ElementClicked = 2

End Sub


'Setup routine for plus/minus

Sub OutlinePlusMinusSetup(PlusPic As Control, PlusFile As String, MinusPic As Control, MinusFile As String)
On Error Resume Next

Set gPlusPic = PlusPic
Set gMinusPic = MinusPic

If PlusFile > "" Then gPlusPic.Picture = LoadPicture(PlusFile)
If MinusFile > "" Then gMinusPic.Picture = LoadPicture(MinusFile)

End Sub



'This is main drawing routine for outline control.

Sub OutlineRefresh(OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, OtlDat() As OtlData)
On Error Resume Next
'Paints control from data array
Dim foo As Integer, foobar As Integer, TotItems As Long
Dim CurrY As Integer, currX As Integer
Dim BmpWidth As Integer, BmpHeight As Integer
Dim TwipsY As Integer, TwipsX As Integer
Dim LineCount As Integer, HoldForeColor As Long
Dim TotVis As Long, SelPnt As Long
ReDim PrevLevelLine(5) As Integer
Dim PrevBmpFile As String
Dim SearchLevel As Integer
If ChangingScroll Then
    Exit Sub 'don't recurse scroll change
End If
TwipsY = Screen.TwipsPerPixelY
TwipsX = Screen.TwipsPerPixelX
'OtlSet.LineHeight = 12 * twipsx
BmpWidth = OtlSet.LineHeight
BmpHeight = OtlSet.LineHeight
'Just changing select bar?
If OtlSet.TopIdx = OtlSet.PrevTop And OtlSet.VisChangeFlag = False Then
    'OtlPic.AutoRedraw = False
    For foo = 0 To OtlSet.DisplayCount
        CurrY = foo * OtlSet.LineHeight
        If OtlSet.DisplayIdx(foo) = OtlSet.SelectIdx Then
            OtlPic.CurrentY = CurrY
            currX = OutlineSetX(3, OtlDat(OtlSet.DisplayIdx(foo)).Level, OtlSet)
            OtlPic.Line (currX, CurrY)-(OtlPic.Width, CurrY + OtlSet.LineHeight - TwipsY), OtlSet.SelectColor, BF
            OtlSet.CurrentLine = foo
            'Print Caption
            OtlPic.CurrentY = CurrY
            OtlPic.CurrentX = currX
            HoldForeColor = OtlPic.ForeColor
            OtlPic.ForeColor = OtlSet.SelectTextColor
            OtlPic.Print " " & OtlDat(OtlSet.DisplayIdx(foo)).Caption
            OtlPic.ForeColor = HoldForeColor
        Else
            If OtlSet.DisplayIdx(foo) = OtlSet.PrevSel Then
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(3, OtlDat(OtlSet.DisplayIdx(foo)).Level, OtlSet)
                OtlPic.Line (currX, CurrY)-(OtlPic.Width, CurrY + OtlSet.LineHeight - TwipsY), OtlPic.BackColor, BF
                'Print Caption
                OtlPic.CurrentY = CurrY
                OtlPic.CurrentX = currX
                OtlPic.Print " " & OtlDat(OtlSet.DisplayIdx(foo)).Caption
            End If
        End If
    Next foo
    'OtlPic.AutoRedraw = True
Else
    Erase OtlSet.DisplayIdx
    OtlPic.Cls
    TotItems = UBound(OtlDat)
    LineCount = 0
    For foo = OtlSet.TopIdx To TotItems
        If OtlDat(foo).Visible = True Then
            CurrY = LineCount * OtlSet.LineHeight
            If LineCount = 0 Then
                OtlSet.TopIdx = foo
            End If
            OtlSet.DisplayIdx(LineCount) = foo
            'Print Select Highlight
            If OtlSet.SelectIdx = foo Then
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(3, OtlDat(foo).Level, OtlSet)
                OtlPic.Line (currX, CurrY)-(OtlPic.Width, CurrY + OtlSet.LineHeight - TwipsY), OtlSet.SelectColor, BF
                OtlSet.CurrentLine = LineCount
                HoldForeColor = OtlPic.ForeColor
                'Print Select Caption
                OtlPic.ForeColor = OtlSet.SelectTextColor
                OtlPic.CurrentY = CurrY
                OtlPic.CurrentX = currX
                OtlPic.Print " " & OtlDat(foo).Caption
                OtlPic.ForeColor = HoldForeColor
            Else
                'Print Caption
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(3, OtlDat(foo).Level, OtlSet)
                OtlPic.CurrentX = currX
                OtlPic.Print " " & OtlDat(foo).Caption
            End If
            'blt bmp
            If OtlSet.BmpFlag = 1 Then
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(2, OtlDat(foo).Level, OtlSet)
                OtlPic.CurrentX = currX
                'do bitmap by kind
                If OtlDat(foo).Level = OtlSet.Levels - 1 Then
                    'Leaf
                    If OtlDat(foo).BmpFileName > "" Then
                        Err = 0
                        If PrevBmpFile <> OtlDat(foo).BmpFileName Then
                            gCustomPic.Picture = LoadPicture(OtlDat(foo).BmpFileName)
                            If Err <> 0 Then
                                Err = 0
                                gCustomPic.Picture = LoadPicture(App.Path & "\" & OtlDat(foo).BmpFileName)
                            End If
                            If Err = 0 Then
                                PrevBmpFile = OtlDat(foo).BmpFileName
                            End If
                        End If
                        If Err = 0 Then
                            OtlPic.PaintPicture gCustomPic.Picture, currX, CurrY
                        Else
                            If OtlSet.CheckmarkFlag And (OtlDat(foo).Selected = 1) Then
                              OtlPic.PaintPicture gLeafCheckedPic.Picture, currX, CurrY
                            Else
                              OtlPic.PaintPicture gLeafPic.Picture, currX, CurrY
                            End If
                        End If
                    Else
                        If OtlSet.CheckmarkFlag And (OtlDat(foo).Selected = 1) Then
                          OtlPic.PaintPicture gLeafCheckedPic.Picture, currX, CurrY
                        Else
                          OtlPic.PaintPicture gLeafPic.Picture, currX, CurrY
                        End If
                    End If
                Else
                    PaintBranchBmp OtlPic, OtlDat(foo).Expanded, OtlDat(foo).Selected, OtlSet.CheckmarkFlag, currX, CurrY
                End If
            End If
            'draw lines with default forecolor
            'MOD FOR EXPLORER STYLE DOTTED LINES...
            If OtlSet.LineFlag = 1 Then
                PrevLevelLine(OtlDat(foo).Level) = LineCount
                currX = OutlineSetX(0, OtlDat(foo).Level, OtlSet)
                DotLine95 OtlPic, currX, CurrY + OtlSet.LineHeight \ 2, currX + OtlSet.ColWidth * 0.6, CurrY + OtlSet.LineHeight \ 2
                If LineCount = 0 Then
                    DotLine95 OtlPic, currX, CurrY + OtlSet.LineHeight \ 2, currX, CurrY
                Else
                    If OtlDat(foo - 1).Level = OtlDat(foo).Level Then
                        DotLine95 OtlPic, currX, CurrY + OtlSet.LineHeight \ 2, currX, CurrY - OtlSet.LineHeight \ 2 '- twipsy
                    Else
                        If OtlDat(foo - 1).Level < OtlDat(foo).Level Then
                            DotLine95 OtlPic, currX, CurrY + OtlSet.LineHeight \ 2, currX, CurrY
                        Else
                            For foobar = LineCount - 1 To 1 Step -1
                                If OtlDat(OtlSet.DisplayIdx(foobar)).Level <= OtlDat(foo).Level Then
                                    Exit For
                                End If
                            Next foobar
                            If OtlDat(OtlSet.DisplayIdx(foobar)).Level <= OtlDat(foo).Level Then
                                DotLine95 OtlPic, currX, CurrY + OtlSet.LineHeight \ 2, currX, OtlSet.LineHeight * (foobar + 1) - OtlSet.LineHeight \ 2
                            Else
                                'Equal level at top or next/any is above limit of control visible area
                                DotLine95 OtlPic, currX, CurrY + OtlSet.LineHeight \ 2, currX, 0 'OtlSet.LineHeight * (foobar + 1) - OtlSet.LineHeight \ 2
                            End If
                        End If
                    End If
                End If
            End If
            
            'set next line
            LineCount = LineCount + 1
            If LineCount >= OtlSet.DisplayLines Or foo = UBound(OtlDat) Then
                Exit For
            End If
        End If
    Next foo
    LineCount = LineCount - 1
    OtlSet.DisplayCount = LineCount
    'Complete Line processing
    If OtlSet.LineFlag = 1 And foo < TotItems Then
        SearchLevel = OtlDat(foo).Level 'Last item displayed
        For foobar = foo + 1 To TotItems
            If OtlDat(foobar).Level <= SearchLevel Then
                currX = OutlineSetX(0, OtlDat(foobar).Level, OtlSet)
                DotLine95 OtlPic, currX, OtlPic.Height, currX, PrevLevelLine(OtlDat(foobar).Level) * OtlSet.LineHeight '- twipsy
                SearchLevel = OtlDat(foobar).Level - 1
                If SearchLevel < 0 Then Exit For
            End If
        Next foobar
    End If
    'draw plus minus boxes
    LineCount = 0
    CurrY = 0
    If (OtlSet.PlusFlag = 1) Then
      For foo = OtlSet.TopIdx To TotItems
        If (OtlDat(foo).Level < OtlSet.Levels - 1) And OtlDat(foo).Visible Then
            CurrY = LineCount * OtlSet.LineHeight + OtlSet.LineHeight / 2 - Screen.TwipsPerPixelY
            currX = OutlineSetX(1, OtlDat(foo).Level, OtlSet)
            OtlPic.CurrentX = currX
            'does the branch have child entries?
            If foo = TotItems Then
                'last entry so no children
                Drawbox Pic:=OtlPic, X:=(currX), Y:=(CurrY), Plus:=False
            Else
                'no kids
                If OtlDat(foo + 1).Level <= OtlDat(foo).Level Then
                    Drawbox Pic:=OtlPic, X:=(currX), Y:=(CurrY), Plus:=False
                    Else
                    'does have children, but is it expanded already?
                    If OtlDat(foo).Expanded = True Then
                        Drawbox Pic:=OtlPic, X:=(currX), Y:=(CurrY), Plus:=False
                    Else 'PLUS - has unexpanded children
                        Drawbox Pic:=OtlPic, X:=(currX), Y:=(CurrY), Plus:=True
                    End If
                End If
            End If
        End If
        If OtlDat(foo).Visible Then
            'set next line
            LineCount = LineCount + 1
            If LineCount >= OtlSet.DisplayLines Or foo = UBound(OtlDat) Then
                Exit For
            End If
        End If
      Next foo
    End If
    'Set Scroll Bar
    'Determine visible items
    If OtlSet.VisChangeFlag Then
        ChangingScroll = True
        OtlSet.VisChangeFlag = False
        OtlSet.VisibleItems = -1
        For foo = 0 To TotItems
            If OtlDat(foo).Visible = True Then
                OtlSet.VisibleItems = OtlSet.VisibleItems + 1
                OtlDat(foo).VisibleIdx = OtlSet.VisibleItems
            Else
                OtlDat(foo).VisibleIdx = -1
            End If
        Next foo
        If OtlSet.VisibleItems > 0 Then
            OtlScroll.Visible = True
            OtlScroll.Max = OtlSet.VisibleItems
        Else
            OtlScroll.Visible = False
            OtlScroll.Value = 0
        End If
        OtlScroll.SmallChange = 1
        OtlScroll.LargeChange = 10
        ChangingScroll = False
    End If
End If
If OtlScroll.Visible = True Then
    ChangingScroll = True
    OtlScroll.Value = OtlDat(OtlSet.SelectIdx).VisibleIdx
    ChangingScroll = False
End If
OtlSet.PrevSel = OtlSet.SelectIdx
OtlSet.PrevTop = OtlSet.TopIdx

End Sub
Public Sub PaintBranchBmp(OtlPic As Object, Expanded As Integer, Selected As Integer, CheckmarkFlag As Integer, currX As Integer, CurrY As Integer)

If CheckmarkFlag = False Then
  If Expanded Then
    OtlPic.PaintPicture gBranchOpenPic.Picture, currX, CurrY
  Else
    OtlPic.PaintPicture gBranchClosedPic.Picture, currX, CurrY
  End If
Else
  If Expanded Then
    Select Case Selected
    Case 0
      OtlPic.PaintPicture gBranchOpenPic.Picture, currX, CurrY
    Case 1
      OtlPic.PaintPicture gBranchOpenAllPic.Picture, currX, CurrY
    Case 2
      OtlPic.PaintPicture gBranchOpenSomePic.Picture, currX, CurrY
    End Select
  Else
    Select Case Selected
    Case 0
      OtlPic.PaintPicture gBranchClosedPic.Picture, currX, CurrY
    Case 1
      OtlPic.PaintPicture gBranchClosedAllPic.Picture, currX, CurrY
    Case 2
      OtlPic.PaintPicture gBranchClosedSomePic.Picture, currX, CurrY
    End Select
  End If
End If

End Sub
                        
                       

Public Function OutlineSetX(ViewType As Integer, Level As Integer, OtlSet As OtlSetup) As Integer
'used for win95 style outlines -- always have bmp, lines, +/-
'ViewType --> 0 = line, 1 = +/- box, 2 = bmp, 3 = text
Dim currX As Integer
OtlSet.ColWidth = 17 * Screen.TwipsPerPixelX
Select Case ViewType
Case 0 'lines
  If Level > 0 Then
    currX = Level * OtlSet.ColWidth + OtlSet.LineHeight \ 2
  Else
    currX = OtlSet.LineHeight \ 2
  End If
Case 1 '+/- box
  If Level > 0 Then
    currX = Level * OtlSet.ColWidth + OtlSet.LineHeight \ 2
  Else
    currX = OtlSet.LineHeight \ 2 + Screen.TwipsPerPixelX
  End If
Case 2 'bmp
  If Level > 0 Then
    currX = Level * OtlSet.ColWidth + OtlSet.ColWidth + Screen.TwipsPerPixelX * 2
  Else
    currX = OtlSet.ColWidth + (Screen.TwipsPerPixelX * 2)
  End If
Case 3 'text caption
  If Level > 0 Then
    currX = Level * OtlSet.ColWidth + OtlSet.ColWidth + OtlSet.LineHeight + (Screen.TwipsPerPixelX * 2)
  Else
    currX = OtlSet.ColWidth + OtlSet.LineHeight + (Screen.TwipsPerPixelX * 2)
  End If
End Select
OutlineSetX = currX
End Function

Sub Drawbox(Pic As Object, X As Long, Y As Long, Plus As Integer)
Dim twips As Integer, Holdstyle As Integer
twips = Screen.TwipsPerPixelY
Holdstyle = Pic.DrawStyle

Pic.Line (X - 4 * twips, Y - 4 * twips)-Step(8 * twips, 8 * twips), &HFFFFFF, BF
Pic.DrawStyle = 0
Pic.Line (X - 4 * twips, Y - 4 * twips)-Step(8 * twips, 8 * twips), &H808080, B
Pic.Line (X - 2 * twips, Y)-Step(5 * twips, 0), &H0
If Plus Then Pic.Line (X, Y - 2 * twips)-Step(0, 5 * twips), &H0
Pic.DrawStyle = Holdstyle

End Sub



Public Sub DotLine95(OtlPic As Control, x1, y1, x2, y2)
'draws horizontal or vertical only ... no angles in this rev
Dim foo As Integer, LowVal, HighVal, TwipsX As Integer, TwipsY As Integer
Dim OtlPicHdc As Long
Dim Checkit As Long
TwipsX = Screen.TwipsPerPixelX
TwipsY = Screen.TwipsPerPixelY
OtlPicHdc = OtlPic.hdc
If x1 = x2 Then
  If y1 < y2 Then
    LowVal = y1
    HighVal = y2
  Else
    LowVal = y2
    HighVal = y1
  End If
  If (LowVal \ TwipsY) Mod 2 = 1 Then LowVal = (LowVal \ TwipsY) * TwipsY - TwipsY
  If (x1 \ TwipsX) Mod 2 = 1 Then x1 = (x1 \ TwipsX) * TwipsX + TwipsX
  For foo = LowVal To HighVal Step TwipsX * 2
    Checkit = SetPixel(OtlPicHdc, x1 / TwipsX, foo / TwipsY, &H808080)
  Next foo
Else
  If x1 < x2 Then
    LowVal = x1
    HighVal = x2
  Else
    LowVal = x2
    HighVal = x1
  End If
  If (LowVal \ TwipsX) Mod 2 = 1 Then
    LowVal = (LowVal \ TwipsX) * TwipsX + TwipsX
    HighVal = (HighVal \ TwipsX) * TwipsX + TwipsX
  End If
  If (HighVal \ TwipsX) Mod 2 = 1 Then HighVal = (HighVal \ TwipsX) * TwipsX + TwipsX
  If (y1 \ TwipsY) Mod 2 = 1 Then y1 = (y1 \ TwipsY) * TwipsY - TwipsY
  For foo = LowVal To HighVal Step TwipsY * 2
    Checkit = SetPixel(OtlPicHdc, foo / TwipsX, y1 / TwipsY, &H808080)
  Next foo
End If
End Sub


'Used to adjust outline control in response to scroll bar changes.

Sub OutlineScroll(ScrollValue As Integer, OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, OtlDat() As OtlData)
Dim foo As Integer, Vispoint As Long
If ChangingScroll Then Exit Sub
Vispoint = -1
If ScrollValue < OtlDat(OtlSet.DisplayIdx(0)).VisibleIdx Then
    For foo = OtlSet.DisplayIdx(0) To 0 Step -1
        If ScrollValue = OtlDat(foo).VisibleIdx Then
            OtlSet.CurrentLine = 0
            OtlSet.SelectIdx = foo
            OtlSet.TopIdx = OtlSet.SelectIdx
            OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()
            Exit For
        End If
    Next foo
Else
    If ScrollValue > OtlDat(OtlSet.DisplayIdx(OtlSet.DisplayCount)).VisibleIdx Then
        'find bottom to select
        For foo = OtlSet.DisplayIdx(OtlSet.DisplayCount) To UBound(OtlDat)
            If ScrollValue = OtlDat(foo).VisibleIdx Then
                OtlSet.CurrentLine = OtlSet.DisplayCount
                OtlSet.SelectIdx = foo
                Exit For
            End If
        Next foo
        'Find TopIdx for display
        For foo = OtlSet.SelectIdx To 1 Step -1
            If OtlDat(foo).VisibleIdx = ScrollValue - OtlSet.DisplayCount Then Exit For
        Next foo
        OtlSet.TopIdx = foo
        OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()
    Else
        For foo = 0 To OtlSet.DisplayCount
            If OtlDat(OtlSet.DisplayIdx(foo)).VisibleIdx = ScrollValue Then
                OtlSet.CurrentLine = foo
                OtlSet.SelectIdx = OtlSet.DisplayIdx(foo)
                OutlineRefresh OtlPic, OtlScroll, OtlSet, OtlDat()
            End If
        Next foo
    End If
End If
OtlPic.SetFocus
End Sub

'Initializes the parameters for a code-based outline control

Sub OutlineSetup(OtlPic As Control, OtlScroll As Control, OtlSet As OtlSetup, DataFields As String, Bmps As Integer, Lines As Integer, Plus As Integer, Checkmarks As Integer, SelectColor As Long, SelectTextColor As Long, BmpField As String, CheckmarkField As String)
'Initializes the OtlSetup control psuedo-properties
'Note: if using bitmaps for bullets, must have pic loaded for branch open, closed, and leaf
Dim foo As Integer
Dim VarArr() As String
ReDim VarArr(0) As String

OtlScroll.Move OtlPic.ScaleWidth - OtlScroll.Width, 0, OtlScroll.Width, OtlPic.ScaleHeight
foo = Parse2Array(DataFields, VarArr(), ",")
DoEvents
OtlSet.Levels = UBound(VarArr) + 1
Erase OtlSet.VariableNames()
For foo = 0 To OtlSet.Levels - 1
    OtlSet.VariableNames(foo) = Trim$(VarArr(foo))
Next foo
If BmpField > "" Then OtlSet.BmpField = BmpField Else OtlSet.BmpField = ""
OtlSet.VisChangeFlag = True 'force first count
If Bmps Then OtlSet.BmpFlag = 1 Else OtlSet.BmpFlag = 0
If Lines Then OtlSet.LineFlag = 1 Else OtlSet.LineFlag = 0
If Plus Then OtlSet.PlusFlag = 1 Else OtlSet.PlusFlag = 0
If Checkmarks Then OtlSet.CheckmarkFlag = True Else OtlSet.CheckmarkFlag = False
OtlSet.CheckmarkField = CheckmarkField
OtlSet.LineHeight = OtlPic.TextHeight("X") '* 1.1
'If OtlSet.LineHeight Mod Screen.TwipsPerPixelY <> 0 Then OtlSet.LineHeight = (OtlSet.LineHeight \ Screen.TwipsPerPixelY) * Screen.TwipsPerPixelY + Screen.TwipsPerPixelY
OtlSet.LineHeight = OtlSet.LineHeight + ((OtlSet.LineHeight \ Screen.TwipsPerPixelY) Mod 4) * Screen.TwipsPerPixelY

OtlSet.DisplayLines = OtlPic.Height \ OtlSet.LineHeight
Erase OtlSet.DisplayIdx
OtlSet.SelectColor = SelectColor
OtlSet.SelectTextColor = SelectTextColor
OtlSet.TopIdx = 0
OtlSet.SelectIdx = 0
OtlSet.PrevTop = -1
OtlSet.PrevSel = -1

End Sub


'Parses text to a passed array based on supplied delimiter
Public Function Parse2Array(ParseString As String, ReturnArray() As String, Delimiter As String) As Integer
On Error Resume Next

Dim CutStart As Integer, CutLength As Integer, LookJump As Integer
Dim foobar As Integer, foo As Integer
Static DelimitPoints(40) As Integer, ArrayUbound As Integer

    If ParseString = "" Then
        Parse2Array = False
        Exit Function
    End If
    'setup delimit points
    Erase DelimitPoints
    For foobar = 1 To 40
        DelimitPoints(foobar) = InStr(DelimitPoints(foobar - 1) + 1, ParseString, Delimiter)
        If DelimitPoints(foobar) = 0 Then
            DelimitPoints(foobar) = Len(ParseString) + 1
            Exit For
        End If
    Next foobar
    ArrayUbound = foobar - 1
    If UBound(ReturnArray) < foobar - 1 Then
        ReDim Preserve ReturnArray(foobar - 1) As String
    End If

    'Cut to array
    For foo = 0 To ArrayUbound
        'setup cut
        CutStart = DelimitPoints(foo) + 1
        CutLength = DelimitPoints(foo + 1) - CutStart
        'cut
        If CutStart > Len(ParseString) Then
            ReturnArray(foo) = ""
        Else
            ReturnArray(foo) = Mid$(ParseString, CutStart, CutLength)
        End If
    Next foo
    Parse2Array = True
End Function

'Stretches a picture to a region in Destination

Sub StrBltAllToPoint(Dest As Object, dX As Integer, dY As Integer, dWidth As Integer, dHeight As Integer, Source As Control)
Dim foo As Integer, DestHoldMode As Integer, SrcHoldMode As Integer

DestHoldMode = Dest.ScaleMode
Dest.ScaleMode = 3 'Pixels
SrcHoldMode = Source.ScaleMode
Source.ScaleMode = 3 'Pixels
 
foo = StretchBlt(Dest.hdc, dX, dY, dWidth, dHeight, Source.hdc, 0, 0, Source.ScaleWidth, Source.ScaleHeight, &HCC0020)

Dest.ScaleMode = DestHoldMode
Source.ScaleMode = SrcHoldMode

End Sub

'Extracts specified item from a delimited list.
Function ParseListText(ParseString As Variant, ReturnPosition As Variant, Delimiter As Variant) As Variant

    Dim CutStart As Integer
    Dim CutLength As Integer
    Dim LookJump As Integer
    Dim foobar As Integer
    Dim foo As Integer
    Static DelimitPoints(100) As Integer
    If ParseString = "" Then
        ParseListText = ""
        Exit Function
    End If
    'setup delimit points
    Erase DelimitPoints
    For foobar = 1 To ReturnPosition
        DelimitPoints(foobar) = InStr(DelimitPoints(foobar - 1) + 1, ParseString, Delimiter)
        If DelimitPoints(foobar) = 0 Then DelimitPoints(foobar) = Len(ParseString) + 1
    Next foobar
    'setup cut
    CutStart = DelimitPoints(ReturnPosition - 1) + 1
    CutLength = DelimitPoints(ReturnPosition) - CutStart
    'cut
    If CutStart > Len(ParseString) Then
        ParseListText = ""
    Else
        ParseListText = Mid$(ParseString, CutStart, CutLength)
    End If
End Function

